package com.utopiaindustries.hseobservationsapp.activities.ObservationForms;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.adapters.ObservationClassAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.ObservationSubClassAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.ShiftAdapter;
import com.utopiaindustries.hseobservationsapp.models.Shift;

import java.util.ArrayList;

public class ObservationOneActivity extends AppCompatActivity {

    private AutoCompleteTextView observationTextview, observationSubTextview;

    private ObservationClassAdapter observationClassAdapter;
    private ObservationSubClassAdapter observationSubClassAdapter;
    private ArrayList<Shift> obClassArrayList = new ArrayList<>();

    private ArrayList<Shift> obSubClassArrayList = new ArrayList<>();

    private Button btnNext;
    ImageView imgBack;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_observation_one);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayout();

        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(ObservationOneActivity.this, ObservationTwoActivity.class);
                startActivity(intent);
            }
        });

        observationTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                // Perform action when shiftTextview item is clicked
                Toast.makeText(ObservationOneActivity.this, "Item clicked: " + obClassArrayList.get(position).getTitle(), Toast.LENGTH_SHORT).show();

            }
        });

        observationSubTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                // Perform action when shiftTextview item is clicked
                Toast.makeText(ObservationOneActivity.this, "Item clicked: " + obSubClassArrayList.get(position).getTitle(), Toast.LENGTH_SHORT).show();

            }
        });
    }

    public void initializeLayout() {
        observationTextview = findViewById(R.id.observation_textview);
        observationSubTextview = findViewById(R.id.observation_sub_textview);
        btnNext = findViewById(R.id.btn_next);
        imgBack = findViewById(R.id.img_back);

        obClassArrayList.add(new Shift(1, "Unsafe Act"));
        obClassArrayList.add(new Shift(2, "Unsafe Condition"));
        obClassArrayList.add(new Shift(3, "Near Miss"));

        observationClassAdapter = new ObservationClassAdapter(this, obClassArrayList);
        observationTextview.setAdapter(observationClassAdapter);

        //observation sub class items
        //for Unsafe
        //for condition
        //never miss
        observationSubClassAdapter = new ObservationSubClassAdapter(this, obSubClassArrayList);
        observationSubTextview.setAdapter(observationSubClassAdapter);
    }
}